<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\property;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\property\PropertyCommission;
use app\common\lists\ListsSearchInterface;
use app\common\model\property\PropertyHead;
use app\common\model\property\PropertyUser;


/**
 * PropertyCommission列表
 * Class PropertyCommissionLists
 * @package app\adminapi\lists
 */
class PropertyCommissionLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/09/20 16:17
     */
    public function setSearch(): array
    {
        return [
            '=' => ['property_head_id', 'property_user_id', 'property_order_id', 'work_id', 'order_amount', 'ratio', 'commission_amount'],

        ];
    }
    public function queryWhere()
    {
        $where = [];
        if(isset($this->params['head_name']) && !empty($this->params['head_name'])){
            $property_head_ids = PropertyHead::where('head_name', 'like', '%'.$this->params['head_name'].'%')->column('id');
            $where[] = ['property_head_id','IN',$property_head_ids];
        }
        if(isset($this->params['householder_name']) && !empty($this->params['householder_name'])){
            $property_user_ids = PropertyUser::where('householder_name', 'like', '%'.$this->params['householder_name'].'%')->column('id');
            $where[] = ['property_user_id','IN',$property_user_ids];
        }
        return $where;
    }
    /**
     * 获取数据权限
     * $this->adminInfo['data_rules']
     * province city admin_id sale_group_id sale_id  property_head_id
     */
    public function queryDataWhere(){
        $where = [];
        $data_rules = $this->adminInfo['data_rules'];
        if (isset($data_rules['province']) && !empty($data_rules['province'])) {
            $where[] = ['province','in' ,$data_rules['province']];
        }
        if (isset($data_rules['city']) && !empty($data_rules['city'])) {
            $where[] = ['city','in' ,$data_rules['city']];
        }
        if(!empty($where)){
            $head_ids = PropertyHead::where($where)->column('id')??[0];
            $where = [['property_head_id','in' ,$head_ids]];
        }
        return $where;
    }
    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/09/20 16:17
     */
    public function lists(): array
    {
        return PropertyCommission::with(['propertyHead','propertyUser'])->where($this->searchWhere)->where($this->queryWhere())->where($this->queryDataWhere())
            ->field(['id', 'property_head_id', 'property_user_id', 'property_order_id', 'work_id', 'order_amount', 'ratio', 'commission_amount'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/09/20 16:17
     */
    public function count(): int
    {
        return PropertyCommission::where($this->searchWhere)->where($this->queryWhere())->where($this->queryDataWhere())->count();
    }

}